#include <iostream>
#include <vector>

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data()
{

    size_t number_count, bin_count;

    cerr << "Enter number count: ";
    cin >> number_count;

    Input in;
    in.numbers.resize(number_count);

    cerr << "Enter numbers: ";

    for (size_t i = 0; i < number_count; i++)
    {
        cin >> in.numbers[i];
    }

    cerr << "Enter number of bins: ";
    cin >> in.bin_count;

    return in;
}
using namespace std;

void find_minmax(const vector<double> &numbers, double &min, double &max)
{
    min = numbers[0];
    for (double x : numbers)
    {

        if (x < min)
        {
            min = x;
        }

        else if (x > max)
        {
            max = x;
        }
    }
}

int main()
{
    Input in = input_data();

    vector<int> bins(in.bin_count);
    vector<double> height(in.bin_count);

    int max_count = bins[0];
    double min = in.numbers[0];
    double max = in.numbers[0];

    find_minmax(in.numbers, min, max);

    double bin_size = (max - min) / in.bin_count;

    for (size_t i = 0; i < in.numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < in.bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;

            if ((lo <= in.numbers[i]) && (in.numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }

        if (!found)
        {
            bins[in.bin_count - 1]++;
        }
    }
    for (int i = 0; i < in.bin_count; i++)
    {
        if (bins[i] > max_count)
        {
            max_count = bins[i];
        }
    }

    for (int i = 0; i < in.bin_count; i++)
    {
        if (bins[i] > MAX_ASTERISK)
        {
            height[i] = (MAX_ASTERISK * bins[i]) / max_count;
        }
        else
            height[i] = bins[i];
    }

    for (int i = 0; i < in.bin_count; i++)
    {

        if (bins[i] < 100)
        {
            cout << " ";
        }

        if (bins[i] < 10)
        {
            cout << " ";
        }

        cout << bins[i] << "|";

        for (int j = 0; j < height[i]; j++)
        {
            cout << "*";
        }
        cout << endl;
    }

    return 0;
}